local addonName = ...
local f = CreateFrame("Frame", "AraWeaponBuffer", UIParent)
local g = CreateFrame"Frame"
local scanner, tip = CreateFrame("GameTooltip","ABWB_GT",nil,"GameTooltipTemplate")
scanner:SetOwner(UIParent, "ANCHOR_NONE")
local configMenu = CreateFrame( "Frame", "ABWB_DD")
configMenu.displayMode = "MENU"

local config
local defaultConfig = {
	scale = 1,
	skipDialog = true,
	icon = "buff",
	text = "none",
	hideLowRanks = false,
	hideWeaponBuffFrame = false,
	notifyLosses = true,
}
local playerGUID, playerClass, invChanged = UnitClass"player"
local L = setmetatable( select(2, ...), { __index = function(t,k) return k end } )
local blocks, blockMH, blockOH, blockR = {}
local blank = { name=L.Undefined, icon="Interface\\Icons\\Spell_Shadow_SacrificialShield" }
local buffList, currentSlot = {}
local buffLost, waitingPopup, UpdateTablet
local timer = 0
local ICON_SIZE, BUTTON_HEIGHT, GAP, TEXT_OFFSET = 16, 18, 10, 4
local iconCoords = { 0.075, 0.925, 0.075, 0.925 }

local next, ipairs, GetWeaponEnchantInfo, GetItemCount, GetItemIcon, GetItemInfo, GetSpellInfo, GetInventoryItemLink =
	next, ipairs, GetWeaponEnchantInfo, GetItemCount, GetItemIcon, GetItemInfo, GetSpellInfo, GetInventoryItemLink


-------------------[[  Poisons | Weightstones | oils  ]]-------------------

local sharpWeapons = {
	[L["Daggers"]] = true,
	[L["One-Handed Axes"]] = true,
	[L["One-Handed Swords"]] = true,
	[L["Two-Handed Axes"]] = true,
	[L["Two-Handed Swords"]] = true,
	[L["Polarms"]] = true,
}
local bluntWeapons = {
	[L["One-Handed Maces"]] = true,
	[L["Two-Handed Maces"]] = true,
	[L["Fist Weapons"]] = true,
}

local buffs, revBuffs = {
	-- fishing lure
	[ 6529] = { cat=1, name=L["Shiny Bauble"],			buffText=L["Fishing Lure (+25 Fishing Skill)"], group=7, rank=1 },
	[ 6530] = { cat=1, name=L["Nightcrawlers"],			buffText=L["Fishing Lure (+50 Fishing Skill)"], group=7, rank=2 },
	[ 6811] = { cat=1, name=L["Aquadynamic Fish Lens"],		buffText=L["Fishing Lure (+50 Fishing Skill)"], group=7, rank=2 },
	[ 6532] = { cat=1, name=L["Bright Bauble"],			buffText=L["Fishing Lure (+75 Fishing Skill)"], group=7, rank=3 },
	[ 7307] = { cat=1, name=L["Flesh Eating Worm"],			buffText=L["Fishing Lure (+75 Fishing Skill)"], group=7, rank=3 },
	[ 6533] = { cat=1, name=L["Aquadynamic Fish Attractor"],	buffText=L["Fishing Lure (+100 Fishing Skill)"],group=7, rank=4 },
	[34861] = { cat=1, name=L["Sharpened Fish Hook"],		buffText=L["Fishing Lure (+100 Fishing Skill)"],group=7, rank=4 },
	[46006] = { cat=1, name=L["Glow Worm"],				buffText=L["Fishing Lure (+100 Fishing Skill)"],group=7, rank=4 },
	[33820] = { cat=1, name=L["Weather-Beaten Fishing Hat"],	buffText=L["Fishing Lure (+75 Fishing Skill)"], group=7, rank=3, hideCount=true },
}, {}

--if playerClass == "PALADIN" then
--	buffs[1] = { name=L[""], }
--end

if playerClass == "SHAMAN" then
	buffs[1] = { name=L["Rockbiter Weapon"],	buffText=L["Rockbiter"],	spellID= 8017 }
	buffs[2] = { name=L["Flametongue Weapon"],	buffText=L["Flametongue"],	spellID= 8024 }
	buffs[3] = { name=L["Frostbrand Weapon"],	buffText=L["Frostbrand"],	spellID= 8033 }
	buffs[4] = { name=L["Earthliving Weapon"],	buffText=L["Earthliving"],	spellID=51730 }
	buffs[5] = { name=L["Windfury Weapon"],		buffText=L["Windfury"],		spellID= 8232 }
end

if playerClass ~= "WARLOCK" and playerClass ~= "MAGE" and playerClass ~= "PRIEST" then -- PHYSICAL
	-- oils
	buffs[ 3824] = { name=L["Shadow Oil"] }
	buffs[ 3829] = { name=L["Frost Oil"] }
	buffs[34539] = { name=L["Righteous Weapon Coating"],	hasDose=true }
	buffs[31535] = { name=L["Bloodboil Poison"] }
	-- sharpening stones
	buffs[ 2862] = { cat=2, name=L["Rough Sharpening Stone"],	buffText=L["Sharpened (+2 Damage)"], group=1, rank=1 }
	buffs[ 2863] = { cat=2, name=L["Coarse Sharpening Stone"],	buffText=L["Sharpened (+3 Damage)"], group=1, rank=2 }
	buffs[ 2871] = { cat=2, name=L["Heavy Sharpening Stone"],	buffText=L["Sharpened (+4 Damage)"], group=1, rank=3 }
	buffs[ 7964] = { cat=2, name=L["Solid Sharpening Stone"],	buffText=L["Sharpened (+6 Damage)"], group=1, rank=4 }
	buffs[12404] = { cat=2, name=L["Dense Sharpening Stone"],	buffText=L["Sharpened (+8 Damage)"], group=1, rank=5 }
	buffs[18262] = { cat=2, name=L["Elemental Sharpening Stone"],	buffText=L["+28 Critical Rating"] }
	buffs[23122] = { cat=2, name=L["Consecrated Sharpening Stone"],	buffText=L["+170 Attack Power vs Undead"] }
	buffs[23528] = { cat=2, name=L["Fel Sharpening Stone"],		buffText=L["Sharpened (+12 Damage)"], group=1, rank=6 }
	buffs[23529] = { cat=2, name=L["Adamantite Sharpening Stone"],	buffText=L["Sharpened (+14 Crit Rating and +12 Damage)"], group=1, rank=7 }
	-- weight stones
	buffs[ 3239] = { cat=3, name=L["Rough Weightstone"],		buffText=L["Weighted (+2 Damage)"], group=2, rank=1 }
	buffs[ 3240] = { cat=3, name=L["Coarse Weightstone"],		buffText=L["Weighted (+3 Damage)"], group=2, rank=2 }
	buffs[ 3241] = { cat=3, name=L["Heavy Weightstone"],		buffText=L["Weighted (+4 Damage)"], group=2, rank=3 }
	buffs[ 7965] = { cat=3, name=L["Solid Weightstone"],		buffText=L["Weighted (+6 Damage)"], group=2, rank=4 }
	buffs[12643] = { cat=3, name=L["Dense Weightstone"],		buffText=L["Weighted (+8 Damage)"], group=2, rank=5 }
	buffs[28420] = { cat=3, name=L["Fel Weightstone"],		buffText=L["Weighted (+12 Damage)"], group=2, rank=6 }
	buffs[28421] = { cat=3, name=L["Adamantite Weightstone"],	buffText=L["Weighted (+14 Crit Rating and +12 Damage)"], group=2, rank=7 }
	-- shield
	buffs[23576] = { cat=4, name=L["Greater Ward of Shielding"] }
end

if playerClass ~= "WARRIOR" and playerClass ~= "DEATHKNIGHT" and playerClass ~= "ROGUE" then -- MAGICAL
	buffs[20744] = { name=L["Minor Wizard Oil"],		hasDose=true, group=3, rank=1 }
	buffs[20746] = { name=L["Lesser Wizard Oil"],		hasDose=true, group=3, rank=2 }
	buffs[20750] = { name=L["Wizard Oil"],			hasDose=true, group=3, rank=3 }
	buffs[22522] = { name=L["Superior Wizard Oil"],		hasDose=true, group=3, rank=4 }
	buffs[20749] = { name=L["Brilliant Wizard Oil"],	hasDose=true, group=3, rank=5 }
	buffs[20745] = { name=L["Minor Mana Oil"],		hasDose=true, group=4, rank=1 }
	buffs[20747] = { name=L["Lesser Mana Oil"],		hasDose=true, group=4, rank=2 }
	buffs[22521] = { name=L["Superior Mana Oil"],		hasDose=true, group=4, rank=3 }
	buffs[20748] = { name=L["Brilliant Mana Oil"],		hasDose=true, group=4, rank=4 }
	buffs[23123] = { name=L["Blessed Wizard Oil"],		buffText=L["+100 Spell Power vs Undead"] }
	buffs[34538] = { name=L["Blessed Weapon Coating"],	hasDose=true }
end


if playerClass == "ROGUE" then
	buffs[ 3775] = { name=L["Crippling Poison"] }
	buffs[ 6947] = { name=L["Instant Poison"] }
	buffs[ 2892] = { name=L["Deadly Poison"] }
	buffs[10918] = { name=L["Wound Poison"] }
	buffs[21835] = { name=L["Anesthetic Poison"] }
	buffs[ 5237] = { name=L["Mind-numbing Poison"] }

	-- old poisons, to keep up to, say, 4.1 ?
	buffs[ 3776] = { name=L["Crippling Poison"] }
	buffs[43231] = { name=L["Instant Poison"] }
	buffs[43233] = { name=L["Deadly Poison"] }
	buffs[43235] = { name=L["Wound Poison"] }
	buffs[43237] = { name=L["Anesthetic Poison"] }

	-- enUS fix: "Mind-numbing Poison" is the only poison that has a different buff text --> "Mind Numbing Poison"
	if GetLocale() == "enUS" then buffs[5237].buffText = "Mind Numbing Poison" end
end


for id, buff in next, buffs do
	buff.id = id
	revBuffs[buff.buffText or buff.name] = buff
end

-----------------------------[[  utilities  ]]-----------------------------

local function SecondsToTime( seconds )
	local perc = seconds / 3600
	return ("|cff%.2x%.2x00%i:%.2i|r"):format( perc < .5 and 255 or 510 - perc*510, perc < .5 and perc*510 or 255, floor(seconds/60), seconds%60 )
end


local function UpdateWeaponInfo()
	for slotName, block in next, blocks do
		local buff, _
		local itemLink = GetInventoryItemLink( "player", block.slotID ) or ""
		block.weaponName, _, _, _, _, _, block.weaponType, _, _, block.weaponIcon = GetItemInfo( itemLink )
		block.weaponIcon = block.weaponIcon or "Interface\\Icons\\INV_Misc_QuestionMark"
		block.weaponID = tonumber( itemLink:match"item:(%d+)" )

		scanner:ClearLines()
		scanner:SetInventoryItem("player", block.slotID)
		for i=5, scanner:NumLines() do
			local line = _G[("ABWB_GTTextLeft%i"):format(i)]
			local r,g,b = line:GetTextColor()
			if r == 0 and g > .99 and b == 0 then
				buff = revBuffs[ line:GetText():match"(.+) %(%d+ .+%)" ]
				if buff then break end
			end
		end
		if buff then config[slotName] = buff end
	end
end


local function SetWeaponBuffFrameVisibility()
	local frame = WeaponBuffaloFrame or TemporaryEnchantFrame
	if config.hideWeaponBuffFrame then
		if frame == TemporaryEnchantFrame then
			frame:Hide()
			TemporaryEnchantFrame:SetWidth(0.000001)
			BuffFrame_Update()
		end
	elseif not startup then
		frame:Show()
		BuffFrame_Update()
	end
end


local highlight = f:CreateTexture()
highlight:SetTexture"Interface\\QuestFrame\\UI-QuestTitleHighlight" -- UI-QuestLogTitleHighlight
highlight:SetBlendMode"ADD"
highlight:SetAlpha(0)

local function ShowBlockHints()
	tip:SetOwner(f, "ANCHOR_NONE")
	tip:SetPoint( f.isTop and "TOP" or "BOTTOM", f, f.isTop and "BOTTOM" or "TOP" )
	tip:AddLine(L["Hints [|cffffffffBlock|r]"])
	tip:AddLine(L["|cffff8020Right-Click|r to show options."], .2,1,.2)
--	tip:AddLine(L["|cffff8020Middle-Click|r to remove buff from "..(currentSlot=="MainHandSlot"and"main hand."or currentSlot=="SecondaryHandSlot"and"off-hand."or"throwing weapon")], .2,1,.2)
	tip:Show()
end

local function Menu_OnEnter(self)
	if self and self.buff then
		highlight:SetAllPoints(self)
		highlight:SetAlpha(1)
		if config.hideHints then return end
		tip:SetOwner(f, "ANCHOR_NONE")
		local showBelow = select(2, f:GetCenter()) > UIParent:GetHeight()/2
		tip:SetPoint(showBelow and "TOP" or "BOTTOM", f, showBelow and "BOTTOM" or "TOP")
		tip:AddLine(L.Hints)
		tip:AddLine(L["|cffff8020Click|r to apply to "..(currentSlot=="MainHandSlot"and"main hand."or currentSlot=="SecondaryHandSlot"and"off-hand."or"throwing weapon")], .2,1,.2)
		tip:AddLine(L["|cffff8020Ctrl+MouseWheel|r to resize tooltip."], .2,1,.2)
		tip:Show()
	end
end

local function Menu_OnLeave(self)
	highlight:ClearAllPoints()
	if self and self.buff then highlight:SetAlpha(0) end
	tip:Hide()
	if not f:IsMouseOver() then f:Hide() end
end

local function SetCustomScale(dialog)
	local val = tonumber( dialog.editBox:GetText():match"(%d+)" )
	if not val or val<70 or val>200 then
		baseScript = BasicScriptErrors:GetScript("OnHide")
		BasicScriptErrors:SetScript("OnHide",Error_OnHide)
		BasicScriptErrorsText:SetText(L"Invalid scale.\nShould be a number between 70 and 200%")
		return BasicScriptErrors:Show()
	end
	config.scale = val/100
end

local function OnMouseWheel(self, delta)
	if not IsControlKeyDown() then return end
	config.scale = config.scale - delta * 0.05
	UpdateTablet()
end

---------------------------[[  secure buttons  ]]--------------------------


local buttons = setmetatable( { }, { __index = function(table,index)
	local button = CreateFrame( "Button", nil, f, "SecureActionButtonTemplate" )
	rawset( table, index, button )
	button:RegisterForClicks"AnyUp"
	button:SetAttribute( "type1", "macro" )
	button:SetAttribute( "type2", "macro" )
	button:SetHeight( BUTTON_HEIGHT )
	button:EnableMouseWheel(true)
	button:SetScript("OnMouseWheel", OnMouseWheel)

	button.icon = button:CreateTexture()
	button.icon:SetWidth( ICON_SIZE ) button.icon:SetHeight( ICON_SIZE )
	button.icon:SetPoint"LEFT"

	button:SetScript("OnEnter", Menu_OnEnter)
	button:SetScript("OnLeave", Menu_OnLeave)

	button.fontLeft = button:CreateFontString(nil, "OVERLAY", "SystemFont_Shadow_Med1")
	button.fontLeft:SetPoint("LEFT", button, "LEFT", ICON_SIZE + TEXT_OFFSET, 0)
	button.fontRight = button:CreateFontString(nil, "OVERLAY", "SystemFont_Shadow_Med1")
	button.fontRight:SetPoint"RIGHT"

	button:SetPoint("TOPLEFT", f, "TOPLEFT", GAP, BUTTON_HEIGHT * (1-index) - GAP)
	return button
end } )


local function SortBuffs(a,b)
	if a.group and a.group == b.group then
		return a.rank < b.rank
	else
		return a.name < b.name
	end
end

local function SetBuffIcon(buff)
	if not buff.icon then
		buff.icon = buff.spellID and select(3,GetSpellInfo(buff.spellID)) or GetItemIcon(buff.id)
	end
end

local function GetBuffList(slot)
	local block = blocks[slot]
	local isFishingPole = block.weaponType == L["Fishing Poles"] -- cat 1
	local isSharpWeapon = sharpWeapons[block.weaponType] -- cat 2
	local isBluntWeapon = bluntWeapons[block.weaponType] -- cat 3
	local isShield = block.weaponType == L.Shields
	local soundDisabled, soundFlag

	wipe(buffList)
	for id, buff in next, buffs do
		if isFishingPole and buff.cat == 1 or not isFishingPole and buff.cat ~= 1 then
			if not buff.cat or
				buff.cat == 1 or
				buff.cat == 2 and isSharpWeapon or
				buff.cat == 3 and isBluntWeapon or
				buff.cat == 4 and isShield
			then
				buff.count = buff.spellID and 1 or GetItemCount(id)
				if buff.count > 0 then
					if buff.hasDose then
						if not soundDisabled then
							soundFlag = GetCVar"Sound_EnableSFX"
							SetCVar("Sound_EnableSFX",0)
							soundDisabled = true
						end
						PickupItem(id)
						PlaceAction(120)
						buff.count = GetActionCount(120)
						PickupAction(120)
						ClearCursor()
					end
					SetBuffIcon(buff)
					buffList[#buffList+1] = buff
				end
			end
		end
	end
	if soundDisabled then SetCVar("Sound_EnableSFX",soundFlag) end
	sort( buffList, SortBuffs )

	if config.hideLowRanks then
		local prevGroup
		for i = #buffList, 1, -1 do
			local buff = buffList[i]
			if prevGroup and prevGroup == buff.group then
				tremove( buffList, i)
			else
				prevGroup = buff.group
			end
		end
	end

	return buffList
end


----------------------------[[  data feed  ]]---------------------------

UpdateTablet = function()
	f:SetScale(config.scale)
	local slotID = currentSlot == "MainHandSlot" and 16 or currentSlot == "SecondaryHandSlot" and 17 or 18
	local prevBuffCount = #buffList
	local buffList = GetBuffList(currentSlot)
	local menuLeftWidth, menuRightWidth = 0, 0
	local itemLeftWidth, itemRightWidth
	local lastBuff = config[currentSlot] or blank

	for i, buff in ipairs(buffList) do
		local button = buttons[i]
		button.buff = buff
		button.icon:SetTexture( buff.icon )
		button.icon:SetTexCoord( unpack(iconCoords) )
		button.fontLeft:SetText( buff.name )
		if buff.spellID or buff.hideCount then
			button.fontRight:SetText""
		else
			button.fontRight:SetFormattedText( "|cffffffff%i|r", buff.count )
		end
		if lastBuff.id == buff.id then
			button.fontLeft:SetTextColor( .9, 0.45, .1 )
		else
			button.fontLeft:SetTextColor( 1, 0.823529, 0 )
		end

		button:SetAttribute( "macrotext1", ("/use %s\n/use %i%s"):format(buff.name, slotID, config.skipDialog and"\n/click StaticPopup1Button1"or"") )

		itemLeftWidth = ICON_SIZE + TEXT_OFFSET + button.fontLeft:GetStringWidth()
		itemRightWidth = button.fontRight:GetStringWidth() + GAP
		if itemLeftWidth > menuLeftWidth then menuLeftWidth = itemLeftWidth end
		if itemRightWidth > menuRightWidth then menuRightWidth = itemRightWidth end
	end

	if #buffList == 0 then
		local button = buttons[1]
		button.buff = nil
		button.icon:SetTexture""
		button.fontLeft:SetText(L["No consumable available."])
		button.fontLeft:SetTextColor( 1, 0.823529, 0 )
		button.fontRight:SetText""
		menuLeftWidth = (ICON_SIZE + TEXT_OFFSET) * 2 + button.fontLeft:GetStringWidth()
	end

	local nbEntries = max( #buffList, 1 )
	for i=1, nbEntries do
		local button = buttons[i]
		button:SetWidth( menuLeftWidth + menuRightWidth )
	end
	f:SetWidth( menuLeftWidth + menuRightWidth + GAP*2 )
	f:SetHeight( BUTTON_HEIGHT * nbEntries + GAP*2 )

	for i = prevBuffCount+1, nbEntries do buttons[i]:Show() end
	for i = nbEntries+1, #buttons do buttons[i]:Hide() end

	if not (f.onBlock or f:IsMouseOver()) then f:Hide() end
end

local function AnchorTablet(anchor, motion, slotName)
	if InCombatLockdown() then return end
	CloseDropDownMenus()
	f:Show()
	local _, y = anchor:GetCenter()
	f.isTop, f.onBlock = y > UIParent:GetHeight() / 2, true
	f:ClearAllPoints()
	f:SetPoint( f.isTop and "TOP" or "BOTTOM", anchor, f.isTop and "BOTTOM" or "TOP" )
	if Skinner then Skinner:applySkin(f) end
	currentSlot = slotName or currentSlot
	if not config.hideHints then ShowBlockHints() end
	UpdateTablet()
end

local function Block_OnLeave(self)
	f.onBlock = nil
	tip:Hide()
	if not f:IsMouseOver() then f:Hide() end
end

local function Block_OnClick(self, button)
	if button == "RightButton" then
		f:Hide() tip:Hide()
		configMenu.scale = UIParent:GetScale()
		ToggleDropDownMenu(1, nil, configMenu, self, 0, 0)
	elseif button == "MiddleButton" then
		CancelItemTempEnchantment(currentSlot == "MainHandSlot" and 1 or 2)
	end
end


-------------------------------[[  options ]]-------------------------------

local function SetOption(bt, var, val)
	config[var] = val or not config[var]
	if var == "hideWeaponBuffFrame" then
		SetWeaponBuffFrameVisibility()
	elseif var == "icon" or var == "text" then
		timer = 0
	end
	if not val then return end
	local sub = bt:GetName():sub(1, 19).."%i"
	for i = 1, bt:GetParent().numButtons do
		local subi = sub:format(i)
		if _G[subi] == bt then
			_G[subi.."Check"]:Show()
		else
			_G[subi.."Check"]:Hide()
			_G[subi.."UnCheck"]:Show()
		end
	end
end

local options = {
	{ text = ("|cFFFFB366Ara|r Weapon Buffer (%s)"):format( GetAddOnMetadata(addonName, "Version") ), isTitle = true },
	{ text = L["Hide low ranks"], check = "hideLowRanks",
	  desc = L["If you have, say, \"Lesser Wizard Oil\" and \"Superior Wizard Oil\",\n the consumable list will only show the later."] },
	{ text = L["Hide weapon buff frame"], check = "hideWeaponBuffFrame" },
	{ text = L["Hide countdown timers"], check = "hideTimers" },
	{ text = L["Notify buff loss"], check = "notifyLosses", submenu = {
		{ text = L["Notify buff loss"], isTitle = true },
		{ text = L["Chat"], check = "notifyChat" },
		{ text = L["Popup"], check = "notifyPopup" },
		{ text = L["Scrolling Battle Text"], check = "notifySBT" } } },
	{ text = L["Delay popup notifications"], check = "delayNotify",
	  desc = L["If a weapon buff wears off during combat,\nthe popup notification will be on hold until it ends."] },
	{ text = L["Skip confirmation dialog"], check = "skipDialog" },
	{ text = L["Set icon as"], submenu = {
		{ text = L["Set icon as"], isTitle = true },
		{ text = L["Weapon"], radio = "icon", val = "weapon" },
		{ text = L["Buff"], radio = "icon", val = "buff" } } },
	{ text = L["Set text as"], submenu = {
		{ text = L["Set text as"], isTitle = true },
		{ text = L["Weapon"], radio = "text", val = "weapon" },
		{ text = L["Buff"], radio = "text", val = "buff" },
		{ text = L["None"], radio = "text", val = "none" } } },
	{ text = L["Tooltip size"], submenu = {
		{ text = "90%", radio = "scale", val = 0.9 },
		{ text ="100%", radio = "scale", val = 1.0 },
		{ text ="110%", radio = "scale", val = 1.1 },
		{ text ="120%", radio = "scale", val = 1.2 },
		{ text = L["Custom..."], radio="scaleX", func=function() StaticPopup_Show"ABWB_SET_SCALE" end }, } },
	{ text = L["Hide hints"], check = "hideHints" }, }

configMenu.initialize = function(self, level)
	if not level then return end
	for i, v in ipairs( level > 1 and UIDROPDOWNMENU_MENU_VALUE or options ) do
		local info = UIDropDownMenu_CreateInfo()
		info.text = v.text
		info.isTitle = v.isTitle
		info.hasArrow = v.submenu ~= nil
		info.value = v.submenu
		if v.desc then
			info.tooltipTitle, info.tooltipText, info.tooltipOnButton = v.text, v.desc, true
		end
		if v.radio then
			if v.radio == "scaleX" then
				info.checked = config.scale ~= .9 and config.scale ~= 1 and config.scale ~= 1.1 and config.scale ~= 1.2
				info.func = v.func
				if info.checked then
					info.text = ("%s (%i%%)"):format(info.text, config.scale*100)
				end
			else
				info.checked = config[v.radio] == v.val
				info.func, info.arg1, info.arg2 = SetOption, v.radio, v.val
				info.keepShownOnClick = true
			end
		elseif v.check then
			info.checked = config[v.check]
			info.func, info.arg1 = SetOption, v.check
			info.keepShownOnClick = true
			info.isNotRadio = true
		else
			info.notCheckable = true
		end
		if level == 1 and info.notCheckable then
			info.text = ("|Tx:%i|t%s"):format(18/self.scale, info.text)
		end
		UIDropDownMenu_AddButton( info, level )
		if level == 1 and info.notCheckable and info.hasArrow then
			local frame = _G[("DropDownList1Button%i"):format(DropDownList1.numButtons)]
			frame:SetPoint("TOPLEFT", 11, select(5,frame:GetPoint())) --
		end
	end
end


---------------------[[  events (and related) stuff  ]]---------------------


local function Timer_OnUpdate( self, elapsed )
	timer = timer - elapsed
	if timer > 0 then return else timer = 1 end

	if invChanged then
		invChanged = false
		UpdateWeaponInfo()
		if f:IsShown() then UpdateTablet() end -- ADDED to reactively change buff list on weapon change
	end

	local _, timeLeft1, _, _, timeLeft2, _, _, timeLeft3 = GetWeaponEnchantInfo()
	blockMH.timeLeft = timeLeft1
	if blockOH then
		blockOH.timeLeft = timeLeft2
		if blockR then blockR.timeLeft = timeLeft3; end
	end

	if buffLost then
		if not buffLost.timeLeft then
			local note = ("|cffff4040-- |T%s:17|t %s |T%s:17|t --|r"):format(buffLost.icon, buffLost.enchantName, buffLost.weaponIcon or "")
			if config.notifyChat then print(note) end
			if config.notifyPopup then
				if config.delayBotify and InCombatLockdown() then
					waitingPopup = "\n"..note
				else
					BasicScriptErrorsText:SetText("\n"..note)
					BasicScriptErrors:Show()
				end
			end
			if config.notifySBT then
				if MikSBT then
					MikSBT.DisplayMessage(note, MikSBT.DISPLAYTYPE_NOTIFICATION, false, 255, 52, 52)
				elseif Parrot then
					Parrot:ShowMessage(note, "Notification", false, 1, .2, .2)
				elseif SCT then
					SCT:DisplayText(note, {r=1, g=.2, b=.2}, nil, "event", 1, 1)
				elseif IsAddOnLoaded"Blizzard_CombatText" then
					CombatText_AddMessage(note, COMBAT_TEXT_SCROLL_FUNCTION, 1, .2, .2)
				end
			end
		end
		buffLost = nil
	end

	for slotName, block in next, blocks do
		local buff = config[slotName] or blank
		block.text = (config.hideTimers and "%s" or config.text == "none" and "%s%s" or "%s [%s]"):format(
			config.text == "buff" and buff.name or config.text == "weapon" and block.weaponName or "",
			block.timeLeft and SecondsToTime( block.timeLeft*.001 ) or L["|cffff0000n/a|r"] )
		if config.icon == "buff" and not buff.icon then SetBuffIcon(buff) end
		block.icon = config.icon == "buff" and buff.icon or block.weaponIcon
	end
end


function f:REPLACE_ENCHANT()
	if not InCombatLockdown() then f:Hide() end tip:Hide()
end

function f:UNIT_INVENTORY_CHANGED(event, unit)
	if unit ~= "player" then return end
	invChanged = true
end

function f.ADDON_LOADED(f, event, addon)
	if addon ~= addonName then return else f:UnregisterEvent(event) end

	AraWeaponBufferDBPC = AraWeaponBufferDBPC or defaultConfig
	config = AraWeaponBufferDBPC
	for k, v in next, defaultConfig do
		if config[k] == nil then config[k] = v end
	end
	if config.text == "poison" then config.text = "buff" end -- fix r1 error
	if config.notifyChat == nil then config.notifyChat = config.notifyLosses end -- r9

	g:RegisterEvent"COMBAT_LOG_EVENT_UNFILTERED"
	f:RegisterEvent"PLAYER_ENTERING_WORLD"
	f:RegisterEvent"PLAYER_REGEN_DISABLED"
	f:RegisterEvent"PLAYER_REGEN_ENABLED"

	tip = _G.GameTooltip
	f:SetClampedToScreen(true)
	f:SetFrameStrata"TOOLTIP"
	f:SetScript("OnEnter", Menu_OnEnter)
	f:SetScript("OnLeave", Menu_OnLeave)
	f:SetScript("OnMouseWheel", OnMouseWheel)

	f:SetBackdrop( { bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		tile=false, tileSize=0, edgeSize=16, insets = { left=3, right=3, top=3, bottom=3 } } )
	f:SetBackdropColor( .1, .1, .1, .85 )
	f:SetBackdropBorderColor( .3, .3, .3, .9 )

	local lib = LibStub("LibDataBroker-1.1")
	local function CreateBlock(name, slotName)
		local block = lib:NewDataObject( "|cFFFFB366Ara|r Weapon Buffer - "..name, {
			text = name,
			type = "data source",
			icon = "Interface\\Icons\\Trade_BrewPoison",
			iconCoords = iconCoords,
			OnEnter = function(self, motion)
				AnchorTablet(self, motion, slotName)
			end,
			OnLeave = Block_OnLeave,
			OnClick = Block_OnClick,
			slot = slotName,
			slotID = (GetInventorySlotInfo(slotName)),
		} )
		blocks[slotName] = block
		return block
	end

	blockMH = CreateBlock("Main Hand", "MainHandSlot")
	if playerClass == "ROGUE" or playerClass == "WARRIOR" or playerClass == "SHAMAN" or playerClass == "HUNTER" or playerClass == "DEATHKNIGHT" then
		blockOH = CreateBlock("Off Hand", "SecondaryHandSlot")
		if playerClass == "ROGUE" then
			blockR = CreateBlock("Ranged", "RangedSlot")
		end
	end

	local dialog = {
		text = L["Set a custom tooltip scale.\nEnter a value between 70 and 200 (%%)."],
		maxLetters = 12,
		OnAccept = SetCustomScale,
		OnShow = function(self) CloseDropDownMenus() self.editBox:SetText(config.scale*100) self.editBox:SetFocus() end,
		EditBoxOnEnterPressed = function(self) local p=self:GetParent() SetCustomScale(p) p:Hide() end,
	}
	for k, v in next, StaticPopupDialogs.ADD_IGNORE do --ADD_MUTE
		if not dialog[k] then dialog[k] = v end
	end
	StaticPopupDialogs.ABWB_SET_SCALE = dialog

	if IsLoggedIn() then f:PLAYER_ENTERING_WORLD() else f:RegisterEvent"PLAYER_ENTERING_WORLD" end
	f.ADDON_LOADED = nil
end

function f:PLAYER_ENTERING_WORLD()
	f:UnregisterEvent"PLAYER_ENTERING_WORLD"
	playerGUID = UnitGUID"player"
	f:RegisterEvent"UNIT_INVENTORY_CHANGED"
	f:RegisterEvent"REPLACE_ENCHANT"
	f.timer = event and 2 or 0
	f:SetScript( "OnUpdate", function(self, elapsed)
		self.timer = self.timer - elapsed
		if self.timer > 0 then return end
		f:SetScript("OnUpdate", nil)
		f:Hide()
		g:SetScript("OnUpdate", Timer_OnUpdate)
		UpdateWeaponInfo()
	end )
	SetWeaponBuffFrameVisibility()
	f.PLAYER_ENTERING_WORLD = nil
end

function f:PLAYER_REGEN_DISABLED()
	f:Hide() tip:Hide()
end

function f:PLAYER_REGEN_ENABLED()
	if waitingPopup then
		BasicScriptErrorsText:SetText(waitingPopup)
		BasicScriptErrors:Show()
		waitingPopup = nil
	end
end

local function OnCombatEvent( frame, event, timestamp, combatEvent, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, enchantName, weaponID, weaponName )
	if combatEvent ~= "ENCHANT_APPLIED" and combatEvent ~= "ENCHANT_REMOVED" then return end
	if dstGUID ~= playerGUID or not blockMH then return end
	local buff = revBuffs[enchantName]
	if not buff then return end

	local block = weaponID == blockMH.weaponID and blockMH or blockOH and weaponID == blockOH.weaponID and blockOH or blockR and weaponID == blockR.weaponID and blockR
	if not block then return --[[print("Issue with weaponID: blockID=",blockMH.weaponID, ", weaponID=",weaponID)]] end
	SetBuffIcon(buff)
	config[block.slot] = buff
	if combatEvent == "ENCHANT_APPLIED" then
		if f:IsShown() then UpdateTablet() end
	elseif config.notifyLosses then
		block.enchantName = enchantName
		buffLost = block
	end
end

g:SetScript( "OnEvent", OnCombatEvent )
f:SetScript( "OnEvent", function(self, event, ...) self[event](self, event, ...) end )

f:RegisterEvent"ADDON_LOADED"