local _, L = ...

local function SetTranslations(...)
	for i=1, select("#",...), 2 do
		local k,v = select(i,...)
		L[k] = v
	end
end

local l = GetLocale()
if l == "deDE" then
	SetTranslations(
		"Fishing Poles",			"Angelruten",
		"Daggers",				"Dolche",
		"One-Handed Axes",			"Einhandäxte",
		"One-Handed Swords",			"Einhandschwerter",
		"Two-Handed Axes",			"Zweihandäxte",
		"Two-Handed Swords",			"Zweihandschwerter",
		"Polarms",				"Stangenwaffen",

		"One-Handed Maces",			"Einhandstreitkolben",
		"Two-Handed Maces",			"Zweihandstreitkolben",
		"Fist Weapons",				"Faustwaffen",

		"Shiny Bauble",				"Gl\195\164nzendes Schmuckst\195\188ck",
		"Fishing Lure (+25 Fishing Skill)",	"Angelk\195\182der (+25 Angelfertigkeit)",
		"Nightcrawlers",			"Nachtkriecher",
		"Fishing Lure (+50 Fishing Skill)",	"Angelk\195\182der (+50 Angelfertigkeit)",
		"Aquadynamic Fish Lens",		"Aquadynamische Fischlinse",
		"Bright Bauble",			"Helle Schmuckst\195\188cke",
		"Fishing Lure (+75 Fishing Skill)",	"Angelk\195\182der (+75 Angelfertigkeit)",
		"Flesh Eating Worm",			"Fleischfressender Wurm",
		"Aquadynamic Fish Attractor",		"Aquadynamischer Fischanlocker",
		"Fishing Lure (+100 Fishing Skill)",	"Angelk\195\182der (+100 Angelfertigkeit)",
		"Sharpened Fish Hook",			"Gesch\195\164rfter Angelhaken",
		"Glow Worm",				"Glühwürmchen",
		"Weather-Beaten Fishing Hat",		"Wettergegerbter Angelhut",

		-- shaman spells
		"Rockbiter Weapon",			"Waffe des Felsbei\195\159ers",
		"Rockbiter ",				"Felsbei\195\159er ",
		"Flametongue Weapon",			"Waffe der Flammenzunge",
		"Flametongue ",				"Flammenzunge ",
		"Frostbrand Weapon",			"Waffe des Frostbrands",
		"Frostbrand ",				"Frostbrand ",
		"Earthliving Weapon",			"Waffe der Lebensgeister",
		"Earthliving ",				"Lebensgeister ",
		"Windfury Weapon",			"Waffe des Windzorns",
		"Windfury ",				"Windzorn ",

		-- physical oils
		"Shadow Oil",				"Schatten\195\182l",
		"Frost Oil",				"Frost\195\182l",
		"Righteous Weapon Coating",		"Rechtschaffene Waffenbeschichtung",
		"Bloodboil Poison",			"Blutbeulengift",

		-- sharpening stones
		"Rough Sharpening Stone",		"Rauer Wetzstein",
		"Sharpened (+2 Damage)",		"Gesch\195\164rft (+2 Schaden)",
		"Coarse Sharpening Stone",		"Grober Wetzstein",
		"Sharpened (+3 Damage)",		"Gesch\195\164rft (+3 Schaden)",
		"Heavy Sharpening Stone",		"Schwerer Wetzstein",
		"Sharpened (+4 Damage)",		"Gesch\195\164rft (+4 Schaden)",
		"Solid Sharpening Stone",		"Robuster Wetzstein",
		"Sharpened (+6 Damage)",		"Gesch\195\164rft (+6 Schaden)",
		"Dense Sharpening Stone",		"Verdichteter Wetzstein",
		"Sharpened (+8 Damage)",		"Gesch\195\164rft (+8 Schaden)",
		"Elemental Sharpening Stone",		"Elementarwetzstein",
		"+28 Critical Rating",			"+28 Kritische Nahkampftrefferwertung",
		"Consecrated Sharpening Stone",		"Geweihter Wetzstein",
		"+170 Attack Power vs Undead",		"+170 Angriffskraft gegen Untote",
		"Fel Sharpening Stone",			"Teuflischer Wetzstein",
		"Sharpened (+12 Damage)",		"Gesch\195\164rft (+12 Schaden)",
		"Adamantite Sharpening Stone",		"Adamantitwetzstein",
		"Sharpened (+14 Crit Rating and +12 Damage)",	"Gesch\195\164rft (+14 Kritische Trefferwertung und +12 Schaden)",

		-- weight stones
		"Rough Weightstone",			"Rauer Gewichtsstein",
		"Weighted (+2 Damage)",			"Beschwert (+2 Schaden)",
		"Coarse Weightstone",			"Grober Gewichtsstein",
		"Weighted (+3 Damage)",			"Beschwert (+3 Schaden)",
		"Heavy Weightstone",			"Schwerer Gewichtsstein",
		"Weighted (+4 Damage)",			"Beschwert (+4 Schaden)",
		"Solid Weightstone",			"Robuster Gewichtsstein",
		"Weighted (+6 Damage)",			"Beschwert (+6 Schaden)",
		"Dense Weightstone",			"Verdichteter Gewichtsstein",
		"Weighted (+8 Damage)",			"Beschwert (+8 Schaden)",
		"Fel Weightstone",			"Teufelsgewichtsstein",
		"Weighted (+12 Damage)",		"Beschwert (+12 Schaden)",
		"Adamantite Weightstone",		"Adamantitgewichtsstein",
		"Weighted (+14 Crit Rating and +12 Damage)",	"Beschwert (+14 Kritische Trefferwertung und +12 Schaden)",

		-- magical oils
		"Minor Wizard Oil",			"Schwaches Zauber\195\182l",
		"Lesser Wizard Oil",			"Geringes Zauber\195\182l",
		"Wizard Oil",				"Zauber\195\182l",
		"Superior Wizard Oil",			"\195\156berragendes Zauber\195\182l",
		"Brilliant Wizard Oil",			"Hervorragendes Zauber\195\182l",
		"Minor Mana Oil",			"Schwaches Mana\195\182l",
		"Lesser Mana Oil",			"Geringes Mana\195\182l",
		"Superior Mana Oil",			"\195\156berragendes Mana\195\182l",
		"Brilliant Mana Oil",			"Hervorragendes Mana\195\182l",
		"Blessed Wizard Oil",			"Gesegnetes Zauber\195\182l",
		"+100 Spell Power vs Undead",		"+100 Zaubermacht gegen Untote",
		"Blessed Weapon Coating",		"Gesegnete Waffenbeschichtung",

		-- rogue poisons
		"Crippling Poison",			"Verkr\195\188ppelndes Gift",
		"Instant Poison",			"Sofort wirkendes Gift",
		"Mind-numbing Poison",			"Gedankenbenebelndes Gift",
		"Deadly Poison",			"T\195\182dliches Gift",
		"Wound Poison",				"Wundgift",
		"Anesthetic Poison",			"Beruhigendes Gift"
	)
elseif l == "frFR" then
	SetTranslations(
		"Fishing Poles",			"Cannes à pêche",
		"Daggers",				"Dagues",
		"One-Handed Axes",			"Haches à une main",
		"One-Handed Swords",			"Epées à une main",
		"Two-Handed Axes",			"Haches à deux mains",
		"Two-Handed Swords",			"Epées à deux mains",
		"Polarms",				"Armes d'hast",

		"One-Handed Maces",			"Masses à une main",
		"Two-Handed Maces",			"Masses à deux mains",
		"Fist Weapons",				"Armes de pugilat",

		"Shiny Bauble",				"Verroterie rutilante",
		"Fishing Lure (+25 Fishing Skill)",	"Appât de pêche (+25 compétence de pêche)",
		"Nightcrawlers",			"Asticots",
		"Fishing Lure (+50 Fishing Skill)",	"Appât de pêche (+50 compétence de pêche)",
		"Aquadynamic Fish Lens",		"Aquadynamische Fischlinse",
		"Bright Bauble",			"Verroterie",
		"Fishing Lure (+75 Fishing Skill)",	"Appât de pêche (+75 compétence de pêche)",
		"Flesh Eating Worm",			"Ver mangeur de chair",
		"Aquadynamic Fish Attractor",		"Attracteur de poissons aquadynamique",
		"Fishing Lure (+100 Fishing Skill)",	"Appât de pêche (+100 compétence de pêche)",
		"Sharpened Fish Hook",			"Hameçon aiguisé",
		"Glow Worm",				"Ver luisant",

		-- shaman spells
		"Rockbiter Weapon",			"Arme Croque-roc",
		"Rockbiter ",				"Croque-roc",
		"Flametongue Weapon",			"Arme Langue de feu",
		"Flametongue",				"Langue de feu ",
		"Frostbrand Weapon",			"Arme de givre",
		"Frostbrand",				"Arme de givre",
		"Earthliving Weapon",			"Arme Viveterre",
		"Earthliving",				"Viveterre",
		"Windfury Weapon",			"Arme Furie-des-vents",
		"Windfury",				"Furie-des-vents",

		-- physical oils
		"Shadow Oil",				"Huile des ténèbres",
		"Frost Oil",				"Huile glaciale",
		"Righteous Weapon Coating",		"Enduit d'arme vertueux",
		"Bloodboil Poison",			"Poison fièvresang",

		-- sharpening stones
		"Rough Sharpening Stone",		"Pierre à aiguiser brute",
		"Sharpened (+2 Damage)",		"Aiguisé (+2 points de dégâts)",
		"Coarse Sharpening Stone",		"Pierre à aiguiser grossière",
		"Sharpened (+3 Damage)",		"Aiguisé (+3 points de dégâts)",
		"Heavy Sharpening Stone",		"Pierre à aiguiser lourde",
		"Sharpened (+4 Damage)",		"Aiguisé (+4 points de dégâts)",
		"Solid Sharpening Stone",		"Pierre à aiguiser solide",
		"Sharpened (+6 Damage)",		"Aiguisé (+6 points de dégâts)",
		"Dense Sharpening Stone",		"Pierre à aiguiser dense",
		"Sharpened (+8 Damage)",		"Aiguisé (+8 points de dégâts)",
		"Elemental Sharpening Stone",		"Pierre à aiguiser élémentaire",
		"+28 Critical Rating",			"+28 au score de critique en mêlée",
		"Consecrated Sharpening Stone",		"Pierre à aiguiser consacrée",
		"+170 Attack Power vs Undead",		"+170 à la puissance d'attaque contre les morts-vivants",
		"Fel Sharpening Stone",			"Pierre à aiguiser gangrenée",
		"Sharpened (+12 Damage)",		"Aiguisé (+12 points de dégâts)",
		"Adamantite Sharpening Stone",		"Pierre à aiguiser adamantine",
		"Sharpened (+14 Crit Rating and +12 Damage)",	"Aiguisé (+14 au score de critique et +12 aux points de dégâts",

		-- weight stones
		"Rough Weightstone",			"Pierre de lest brute",
		"Weighted (+2 Damage)",			"Equilibré (+2 points de dégâts)",
		"Coarse Weightstone",			"Pierre de lest grossière",
		"Weighted (+3 Damage)",			"Equilibré (+3 points de dégâts)",
		"Heavy Weightstone",			"Pierre de lest lourde",
		"Weighted (+4 Damage)",			"Equilibré (+4 points de dégâts)",
		"Solid Weightstone",			"Pierre de lest solide",
		"Weighted (+6 Damage)",			"Equilibré (+6 points de dégâts)",
		"Dense Weightstone",			"Pierre de lest dense",
		"Weighted (+8 Damage)",			"Equilibré (+8 points de dégâts)",
		"Fel Weightstone",			"Pierre de lest gangrenée",
		"Weighted (+12 Damage)",		"Equilibré (+12 points de dégâts)",
		"Adamantite Weightstone",		"Pierre de lest d'adamantite",
		"Weighted (+14 Crit Rating and +12 Damage)",	"Équilibré (+14 au score de crit. et +12 aux points de dégâts",

		-- magical oils
		"Minor Wizard Oil",			"Huile de sorcier mineure",
		"Lesser Wizard Oil",			"Huile de sorcier inférieure",
		"Wizard Oil",				"Huile de sorcier",
		"Superior Wizard Oil",			"Huile de sorcier excellente",
		"Brilliant Wizard Oil",			"Huile de sorcier brillante",
		"Minor Mana Oil",			"Huile de mana mineure",
		"Lesser Mana Oil",			"Huile de mana inférieure",
		"Superior Mana Oil",			"Huile de mana excellente",
		"Brilliant Mana Oil",			"Huile de mana brillante",
		"Blessed Wizard Oil",			"Huile de sorcier bénie",
		"+100 Spell Power vs Undead",		"+100 à la puissance des sorts contre les morts-vivants",
		"Blessed Weapon Coating",		"Enduit d'arme béni",

		-- rogue poisons
		"Crippling Poison",			"Poison affaiblissant",
		"Instant Poison",			"Poison instantané",
		"Mind Numbing Poison",			"Poison de distraction mentale",
		"Deadly Poison",			"Poison mortel",
		"Wound Poison",				"Poison douloureux",
		"Anesthetic Poison",			"Poison anesthésiant"
	)
elseif l == "ruRU" then
	SetTranslations(
		-- rogue poisons
		"Crippling Poison",	"Калечащий яд",
		"Instant Poison",	"Быстродействующий яд",
		"Mind Numbing Poison",	"Дурманящий яд",
		"Deadly Poison",	"Смертельный яд",
		"Wound Poison",		"Нейтрализующий яд",
		"Anesthetic Poison",	"Анестезирующий яд"
	)
end